## Export of "larger" Sql Server Blob to file            
## with GetBytes-Stream.         
# Configuration data            
cls
write-host "Export pictures out of the PIC table"
write-host "Photos will overwrite previous ones in output path. Older ones will not be removed from prior output"
write-host "This script can be modified to contain static values if you wish to have it run on a SECURE computer"
write-host 
write-host "What option would you like"
write-host "1 - Export the entire PIC table with file names of PermID_Year.jpg"
write-host "2 - Export the entire PIC table with file names of LN,FN_PermID_Year.jpg"
write-host "3 - Export active pictures only as PermID.jpg"
write-host "4 - Export active pictures only as LN,FN_PermID.jpg"
write-host "5 - Export active pictures only for just one school as PermID.jpg"
write-host "6 - Export active pictures only for just one school as LN,FN_PermID.jpg"
write-host "7 - Export active pictures only for just one school and section as PermID.jpg"
write-host "8 - Export active pictures only for just one school and section as LN,FN_PermID.jpg"
write-host "9 - Export active pictures only for just one school and grade as PermID.jpg"
write-host "0 - Export active pictures only for just one school and grade as LN,FN_PermID.jpg"
write-host 
$Option= Read-host "?"


if (@("5","6","7","8","9","0") -contains $Option) {$response = Read-host "What School of students will be exported?"
$School = $response}


if (@("9","0") -contains $Option) {$response = Read-host "What grade of students will be exported?"
$Grade = $response}

if (@("7","8") -contains $Option) {$response = Read-host "What section will be exported?"
$Section = $response}


$response = Read-host "What SQL Server name or IP?"
$Server = $response

$response = Read-host "What full database name? (e.g. DST15000AeriesDemo_ID)"
$Database = $response

Function Select-FolderDialog
{
    param([string]$Description="Select Folder",[string]$RootFolder="Desktop")

 [System.Reflection.Assembly]::LoadWithPartialName("System.windows.forms") |
     Out-Null     

   $objForm = New-Object System.Windows.Forms.FolderBrowserDialog
        $objForm.Rootfolder = $RootFolder
        $objForm.Description = $Description
        $Show = $objForm.ShowDialog()
        If ($Show -eq "OK")
        {
            Return $objForm.SelectedPath + "\"
        }
        Else
        {
            Write-Error "Operation cancelled by user."
        }
    }

$Dest = Select-FolderDialog
write-host "You chose a destination of $Dest"

$response = Read-host "What's your SQL User Name?" -AsSecureString
$SQLuser = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))

$response = Read-host "What's your password?" -AsSecureString
$password = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))

$bufferSize = 8192;               # Stream buffer size in bytes.            

# Select-Statement for name & blob            
# with filter.            
if ($Option -eq "1") {$Sql = "select cast(id as varchar(10)) + '_' + cast(yr as varchar(4)) + '.' + xt as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and id in (select id from stu where del = 0 and tg = '') order by id"}
if ($Option -eq "2") {$Sql = "select replace(replace(replace(replace(replace(replace(replace(replace(replace((select top 1 ln + ', ' + fn from stu where id = pic.id and del = 0 order by ed desc) + '_' + cast(id as varchar(10)) + '_' + cast(yr as varchar(4)) + '.' + xt,'\',''),'/',''),':',''),'*',''),'?',''),'""',''),'<',''),'>',''),'|','') as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and del = 0 and id in (select id from stu where del = 0 and tg = '')"}
if ($Option -eq "3") {$Sql = "select cast(id as varchar(10))+'.'+xt as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '')"}
if ($Option -eq "4") {$Sql = "select replace(replace(replace(replace(replace(replace(replace(replace(replace((select top 1 ln + ', ' + fn from stu where id = pic.id and del = 0 order by ed desc) + '_' + cast(id as varchar(10))+'.'+xt,'\',''),'/',''),':',''),'*',''),'?',''),'""',''),'<',''),'>',''),'|','') as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '')"}
if ($Option -eq "5") {$Sql = "select cast(id as varchar(10))+'.'+xt as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '') and id in (select id from stu where sc = $School and del = 0 and tg = '')"}
if ($Option -eq "6") {$Sql = "select replace(replace(replace(replace(replace(replace(replace(replace(replace((select top 1 ln + ', ' + fn from stu where id = pic.id and del = 0 order by ed desc) + '_' + cast(id as varchar(10))+'.'+xt,'\',''),'/',''),':',''),'*',''),'?',''),'""',''),'<',''),'>',''),'|','') as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '') and id in (select id from stu where sc = $School and del = 0 and tg = '')"}
if ($Option -eq "7") {$Sql = "select cast(id as varchar(10))+'.'+xt as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where sc = $School and del = 0 and tg = '') and id in (select stu.id from stu inner join sec on stu.sc = sec.sc and stu.sn = sec.sn inner join mst on sec.sc = mst.sc and sec.se = mst.se where sec.del = 0 and mst.del = 0 and stu.sc = $School and sec.se = $Section)"}
if ($Option -eq "8") {$Sql = "select replace(replace(replace(replace(replace(replace(replace(replace(replace((select top 1 ln + ', ' + fn from stu where id = pic.id and del = 0 order by ed desc) + '_' + cast(id as varchar(10))+'.'+xt,'\',''),'/',''),':',''),'*',''),'?',''),'""',''),'<',''),'>',''),'|','') as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where sc = $School and del = 0 and tg = '') and id in (select stu.id from stu inner join sec on stu.sc = sec.sc and stu.sn = sec.sn inner join mst on sec.sc = mst.sc and sec.se = mst.se where sec.del = 0 and mst.del = 0 and stu.sc = $School and sec.se = $Section)"}
if ($Option -eq "9") {$Sql = "select cast(id as varchar(10))+'.'+xt as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '' and gr = $Grade) and id in (select id from stu where sc = $School and del = 0 and tg = '') order by id"}
if ($Option -eq "0") {$Sql = "select replace(replace(replace(replace(replace(replace(replace(replace(replace((select top 1 ln + ', ' + fn from stu where id = pic.id and del = 0 order by ed desc) + '_' + cast(id as varchar(10))+'.'+xt,'\',''),'/',''),':',''),'*',''),'?',''),'""',''),'<',''),'>',''),'|','') as Filename, rb as Document from pic where xt in ('jpg','bmp','png','gif') and yr = (select max(yr) from pic as maxyr where id = pic.id) and del = 0 and id in (select id from stu where del = 0 and tg = '' and gr = $Grade) and id in (select id from stu where sc = $School and del = 0 and tg = '') order by id"}

write-host $SQL

            
# Open ADO.NET Connection            
$con = New-Object Data.SqlClient.SqlConnection;            
$con.ConnectionString = "Data Source=$Server;" +             
                        "User ID=$SQLuser;" +            
                        "password=$password;" +            
                        "Initial Catalog=$Database";            
$con.Open();            
            
# New Command and Reader            
$cmd = New-Object Data.SqlClient.SqlCommand $Sql, $con;            
$rd = $cmd.ExecuteReader();            
            
# Create a byte array for the stream.            
$out = [array]::CreateInstance('Byte', $bufferSize)            
            
# Looping through records            
While ($rd.Read())            
{            
    Write-Output ("Exporting: {0}" -f $rd.GetString(0));                    
    # New BinaryWriter            
    $fs = New-Object System.IO.FileStream ($Dest + $rd.GetString(0)), Create, Write;            
    $bw = New-Object System.IO.BinaryWriter $fs;            
               
    $start = 0;            
    # Read first byte stream            
    $received = $rd.GetBytes(1, $start, $out, 0, $bufferSize - 1);            
    While ($received -gt 0)            
    {            
       $bw.Write($out, 0, $received);            
       $bw.Flush();            
       $start += $received;            
       # Read next byte stream            
       $received = $rd.GetBytes(1, $start, $out, 0, $bufferSize - 1);            
    }            
            
    $bw.Close();            
    $fs.Close();            
}            
            
# Closing & Disposing all objects            
$fs.Dispose();            
$rd.Close();            
$cmd.Dispose();            
$con.Close();            
            
Write-Output ("Finished");
